
/************************************************
Java Script Interpreter
Author: DEM0STEN
Contacts and bug reports -> http://demosten.com OR stjordanov@hotmail.com

Error and warnings definitions

************************************************/

#ifndef _JSI_ERRORS_H_
#define _JSI_ERRORS_H_

// ERROR definitions and codes

// MISC definitions
#define JSI_UNKNOWN                 			0xFFFFFFFFUL // unknown line/column

#define JSIE_SUCCESS							0		// "Ok"

// Error definitions - made 50 number groups by type

// general and preprocess errors 1 to 50
#define JSIE_FILE_NOT_FOUND						1		// "File not found"
#define JSIE_INVALID_INPUT_CHAR     			2		// "Invalid input character"
#define JSIE_IO_ERROR							3		// "I/O error"
#define JSIE_NOT_ENOUGH_MEMORY					4		// "Not enough memory"

// parse errors 51 to 100
#define JSIE_MISSING_OPEN						51		// "'(' exprected"
#define JSIE_MISSING_INDEX_ID					52		// "Missing index identifer '[]'"
#define JSIE_TOO_MANY_OPEN						53		// "Unexpected '(' found"
#define JSIE_INVALID_IDENTIFER      			54		// "Invalid identifer"
#define JSIE_UNFINISHED_STRING      			55		// "Unfinished string constant"
#define JSIE_INVALID_STRING_CONST				56		// "Invalid string constant"
#define JSIE_INVALID_IF_STATE					57		// "Invalid if() syntax"
#define JSIE_INVALID_WHILE_STATE				58		// "Invalid while() syntax"
#define JSIE_INVALID_FOR_STATE					59		// "Invalid 'for' syntax"
#define JSIE_INVALID_FUNCTION_DEFINITION		60		// "Invalid function definition"
#define JSIE_OUTSIDE_CONTINUE					61		// "'continue' used outside of loop statement"
#define JSIE_OUTSIDE_BREAK						62		// "'break' used outside of loop statement"
#define JSIE_INVALID_OPERATION					63		// "Invalid operation"
#define JSIE_INVALID_FUNCTION_CALL				64		// "Invalid function call"
#define JSIE_INVALID_FUNCTION_ARGUMENT			65		// "Invalid function argument"
#define JSIE_INVALID_VARIABLE_TYPE				66		// "Invalid variable type"
#define JSIE_INVALID_VARIABLE_NAME				67		// "Invalid variable name"
#define JSIE_CANNOT_ASSIGN_TO_FUNCTION			68		// "Cannot assign to function"
#define JSIE_MISSING_BLOCK_CLOSE				69		// "Missing block end '}'"

// runtime specific errors 101 to 150
#define JSIE_DIVIDE_BY_ZERO						101		// "Divide by zero"

// user defined function errors 151 to 200
#define JSIE_EXTR_FUNC_MUST_RETURN				151		// "External function must return a value"
#define JSIE_EXTR_VAR_IS_READ_ONLY				152		// "External variable is read only"
#define JSIE_EXTR_VAR_IS_WRITE_ONLY				153		// "External variable is write only"
#define JSIE_EVAL_WITH_ONE_ARG					154		// "eval() takes 1 argument"
#define JSIE_PARSEINT_WITH_ONE_ARG				155		// "parseInt() takes 1 argument"
#define JSIE_PARSEFLOAT_WITH_ONE_ARG			156		// "parseFloat() takes 1 argument"

// WARNINGS


// FUNCTIONS
void JSI_SetError(int iErr, DWORD dwColumn);
void JSI_SetErrorColumn(DWORD dwColumn);
#ifdef _JSI_WIN32_
int WINAPI JSI_GetError(DWORD *pdwLine, DWORD *pdwColumn);
#else
int JSI_GetError(DWORD *pdwLine, DWORD *pdwColumn);
#endif

#endif
