/************************************************
Java Script Interpreter
Author: DEM0STEN
Contacts and bug reports -> http://demosten.com OR stjordanov@hotmail.com

trace output routines

************************************************/

#include <stdio.h>
#include <stdarg.h>
#include "JSI_defs.h"

#ifdef _JSI_DEBUG_

static FILE *fTrace = NULL;

/************************************************
Trace() - perform trace output to screen and file
************************************************/
void Trace(char *szFormat, ...)
{
va_list args;

	va_start(args, szFormat);
	vprintf(szFormat, args);

	if (fTrace) {
		vfprintf(fTrace, szFormat, args);
		fflush(fTrace);
	}
	va_end(args);
}
/************************************************
TraceInit() - create and open trace file
************************************************/
void TraceInit(void)
{
	fTrace = fopen("JS_TRACE.$$$", "wt");
	Trace("Tracing started\n");
}
/************************************************
TraceClose() - close trace file
************************************************/
void TraceClose(void)
{
	fclose(fTrace);
}

#endif