/************************************************
Java Script Interpreter
Author: DEM0STEN
Contacts and bug reports -> http://demosten.com OR stjordanov@hotmail.com

debug routines

************************************************/

#include <stdio.h>
#include <stdarg.h>
//#include "jsi.h"
#include "JSI_defs.h"
#include "JSI_vars.h"
#include "JSI_errw.h"
#include "JSI_dbg.h"

// debug callback function address
pJSI_DebugCallback pfDebug = NULL;
// current local heap set by JSI_CallFunction()
PVar *ppvCurrentLocalHeap = NULL; // TODO init at startup

// DEFINED IN JSI_MAIN.C
extern PVar pvGlobalHeap;

// DEFINED IN JSI_INTR.C
extern TPostfix pfCallResult;

PVar JSI_FindVar(char *szName, PVar pvLocalHeap); 
typedef int (JSI_CALLBACK *pJSI_VarGet)(void);

/************************************************
JSI_SetDebugCallback() - set debug callback pointer
************************************************/
void JSI_SetDebugCallback(pJSI_DebugCallback func)
{
	pfDebug = func;
}
/************************************************
PostfixType2VarType() - convers TOpType to TVarType
************************************************/
TVarType PostfixType2VarType(TOpType Type)
{
	switch (Type) {
	case opConstNum: return varNum;
	case opConstStr: return varStr;
	}
	return varError;
}
/************************************************
JSI_GetVarValue() - get variable value (return opError for error)
************************************************/
TVarType JSI_DebugGetVar(char *szName, char **szValue, double *dValue)
{
PVar pvar;
pJSI_VarGet func;

	#ifdef _JSI_DEBUG_
	Trace("\JSI_DebugGetVar(): '%s'\n", szName);
	#endif

	if (ppvCurrentLocalHeap == NULL) 
		pvar = JSI_FindVar(szName, pvGlobalHeap);
	else
		pvar = JSI_FindVar(szName, *ppvCurrentLocalHeap);

	if (pvar != NULL) {
		switch (pvar->Type) {
		case varNum: *szValue = NULL; *dValue = pvar->dValue; break;
		case varStr: *szValue = pvar->szValue; *dValue = 0.0; break;
		case varObj: case varFunc: case varExtFunc: break;
		case varExtVar:
			func = (pJSI_VarGet)pvar->code;
			if (func) {
				pfCallResult.Type = opError;
				func();
				if (pfCallResult.Type == opError)
					JSI_SetError(JSIE_EXTR_FUNC_MUST_RETURN, JSI_UNKNOWN);
				else {
					*dValue = pfCallResult.dValue;
					*szValue = pfCallResult.szValue;
				}
				pvar->Type = PostfixType2VarType(pfCallResult.Type);
				break;
			}
			else {
				JSI_SetError(JSIE_EXTR_VAR_IS_WRITE_ONLY, JSI_UNKNOWN);
				return varError;
			}
		default:
			JSI_SetError(JSIE_INVALID_VARIABLE_TYPE, JSI_UNKNOWN);
			return varError;
		}
	}
	return varError;
}
