
/************************************************
Java Script Interpreter
Author: DEM0STEN
Contacts and bug reports -> http://demosten.com OR stjordanov@hotmail.com

Main definitions

************************************************/

#ifndef _JSI_DEFS_H_
#define _JSI_DEFS_H_

//#define _16bit_CC_ 		// comment this line for 32 bit compilers
//#define _JSI_DEBUG_     // comment this line to prevent debug output
#ifdef _JSI_DEBUG_
	//#define _JSI_DEBUG_MEM_ // comment this line to prevent memory debug output
	//#define _JSI_DEBUG_PF_ // comment this line to prevent postfix stack debug output
	#define _JSI_DEBUG_VAR_ // comment this line to prevent variable stack debug output
#endif // #ifdef _JSI_DEBUG_

#define _JSI_WIN32_		// comment this for non Win32 platforms

#define MAX_VALUE_SIZE	100
#define MAX_WORD 		65535
#define TRUE			1
#define FALSE			0

#ifdef _JSI_WIN32_
	#include <windows.h>
	#define JSI_EXPORT		WINAPI
	#define JSI_CALLBACK	CALLBACK
#else
	typedef unsigned long 	DWORD;
	typedef int           	BOOL;
	typedef unsigned char   BYTE;
	#define JSI_EXPORT
	#define JSI_CALLBACK
#endif

#ifdef _16bit_CC_
typedef unsigned int  	WORD;
#else
	#ifndef _JSI_WIN32_
	typedef unsigned short  WORD;
	#endif
#endif

#endif
