
/************************************************
Java Script Interpreter
Author: DEM0STEN
Contacts and bug reports -> http://demosten.com OR stjordanov@hotmail.com

interpreter execute fuctions

************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "JSI_defs.h"
#include "JSI_errw.h"
#include "JSI_vars.h"
#include "JSI_expr.h"
#include "JSI_pars.h"
#include "JSI_trc.h"
#include "JSI_dbg.h"

extern PVar pvGlobalHeap;

// DEFINED IN JSI_PARS.C
extern DWORD dwCurLine;		// current line number

// debug callback function address
extern pJSI_DebugCallback pfDebug;	// JSI_dbg.c

// from JSI_EXPR.C
TPostfix CalcPostfix(PPostfix inp, PVar *pvLocalHeap);
extern TPostfix pfNone;
extern TPostfix pfError;

// DEFINED IN JSI_ERRW.C
extern BOOL bRuntimeError;	// indicates runtime error


/************************************************
JSI_Exec() - main execute routine
************************************************/
TPostfix JSI_Exec(PToken Token, PVar *ppvLocalHeap)
{
PToken ptIP = Token; 	// instruction pointer
TPostfix pfResult;		// expression result
//int iResult;			// Calculation success result
BOOL bResult;			// Calculation result BOOL

	#ifdef _JSI_DEBUG_VAR_
	PrintVar(pvGlobalHeap);
	if (pvGlobalHeap != (*ppvLocalHeap))
		PrintVar(*ppvLocalHeap);
	#endif
	#ifdef _JSI_DEBUG_
	Trace("\nJSI_Exec(): heap: (%p)\n", *ppvLocalHeap);
	#endif
	bRuntimeError = TRUE;
	while (ptIP != NULL) {
		if (ptIP->Type == tNop) {	// goto next IP if current is NOP
			ptIP = ptIP->nextFalse;
			continue;
		}
		// calling debug
		if ((pfDebug != NULL) && (dwCurLine != ptIP->dwLine))
			pfDebug(ptIP->dwLine);		// call debug function callback
		
		dwCurLine = ptIP->dwLine;	// update current line information
		// main callculation
		pfResult = CalcPostfix(ptIP->pfExpr, ppvLocalHeap);
		if (pfResult.Type == opError) // calc error?
			return pfResult;
		if (ptIP->Type == tReturn)
			return pfResult;
		if (JSI_GetError(NULL, NULL) != JSIE_SUCCESS)
			return pfError;
		// make it BOOL
		switch (pfResult.Type) {
		case opConstNum: bResult = (pfResult.dValue == 0) ? FALSE : TRUE; break;
		case opConstStr: bResult = (strlen(pfResult.szValue) == 0) ? FALSE : TRUE; break;
		case opVarStr:
		case opVar: bResult = TRUE; break;
		case opNone: bResult = FALSE; break;
		default:
			JSI_SetError(JSIE_INVALID_VARIABLE_TYPE, JSI_UNKNOWN);
			break;
		}
		// update IP
		if ((ptIP->Type == tIf) && (bResult))
			ptIP = ptIP->nextTrue;
		else
			ptIP = ptIP->nextFalse;
	}
	#ifdef _JSI_DEBUG_VAR_
	PrintVar(pvGlobalHeap);
	if (pvGlobalHeap != (*ppvLocalHeap))
		PrintVar(*ppvLocalHeap);
	#endif
	#ifdef _JSI_DEBUG_
	Trace("\nJSI_Exec() ... OK\n");
	#endif
//	return pfNone;
	return pfResult; // TODO ???
}
