
/************************************************
Java Script Interpreter
Author: DEM0STEN
Contacts and bug reports -> http://demosten.com OR stjordanov@hotmail.com

biultin functions code and define

************************************************/

#include <math.h>
#include <stdlib.h>
#include <string.h>
#include "JSI_defs.h"
#include "JSI_errw.h"
#include "JSI_expr.h"
#include "JSI_pars.h"
#include "JSI_vars.h"
#include "JSI_mem.h"
#include "JSI_trc.h"
#include "JSI_intr.h"
#include "JSI_exec.h"

// global vars
static char szNaN[] = "NaN";		// Not A Number return value

// external variable definitions
extern TPostfix pfCallResult;  // JSI_INTR.C
extern TPostfix pfError;
extern PVar pvGlobalHeap;   // JSI_MAIN.C
extern DWORD dwCurLine; 	// current line number DEFINED IN JSI_PARS.C
// external function definitions
TPostfix JSI_Interpret(char *szMem); // JSI_MAIN.C

/************************************************
JSI_Eval() - C code for eval() builtin function
************************************************/
BOOL JSI_CALLBACK JSI_Eval(int argc, PVar argv)
{
char *szValue;
double dValue;
TOpType Type;

	if (argc != 1) {
		JSI_SetError(JSIE_EVAL_WITH_ONE_ARG, JSI_UNKNOWN);
		return FALSE;
	}
	if ((Type = JSI_GetParam(0, &szValue, &dValue, argv)) == varNum)
		JSI_SetResult(NULL, dValue, Type);
	else
		pfCallResult = JSI_Interpret(szValue);

	return TRUE;
}
/************************************************
JSI_ParseInt() - C code for parseInt() builtin function
************************************************/
BOOL JSI_CALLBACK JSI_ParseInt(int argc, PVar argv)
{
char *szValue, *cError;
double dValue;
int iValue;
TOpType Type;

	if (argc != 1) {
		JSI_SetError(JSIE_PARSEINT_WITH_ONE_ARG, JSI_UNKNOWN); // TODO
		return FALSE;
	}
	if ((Type = JSI_GetParam(0, &szValue, &dValue, argv)) == varNum)
		JSI_SetResult(NULL, (double)((int)dValue), Type);
	else {
		iValue = strtol(szValue, &cError, 0);
		if (cError == szValue)
			JSI_SetResult(szNaN, 0.0, varStr);
		else
			JSI_SetResult(NULL, (double)iValue, varNum);
	}
	return TRUE;
}
/************************************************
JSI_ParseFloat() - C code for parseFloat() builtin function
************************************************/
BOOL JSI_CALLBACK JSI_ParseFloat(int argc, PVar argv)
{
char *szValue, *cError;
double dValue;
TOpType Type;

	if (argc != 1) {
		JSI_SetError(JSIE_PARSEFLOAT_WITH_ONE_ARG, JSI_UNKNOWN); // TODO
		return FALSE;
	}
	if ((Type = JSI_GetParam(0, &szValue, &dValue, argv)) == varNum)
		JSI_SetResult(NULL, dValue, Type);
	else {
		dValue = strtod(szValue, &cError);
		if ((cError == szValue) ||
			(dValue == HUGE_VAL) ||
			(dValue == -HUGE_VAL))
			JSI_SetResult(szNaN, 0.0, varStr);
		else
			JSI_SetResult(NULL, dValue, varNum);
	}
	return TRUE;
}
/************************************************
JSI_SetBiultInFunctions() - set all implemented builtin functions
************************************************/
BOOL JSI_SetBiultInFunctions(void)
{
	if (!JSI_AddExtrFunction("eval", JSI_Eval))
		return FALSE;
	if (!JSI_AddExtrFunction("parseInt", JSI_ParseInt))
		return FALSE;
	if (!JSI_AddExtrFunction("parseFloat", JSI_ParseFloat))
		return FALSE;
	return TRUE;
}
