
/************************************************
Java Script Interpreter
Author: DEM0STEN
Contacts and bug reports -> http://demosten.com OR stjordanov@hotmail.com
(http://demosten.com/jsi) TODO

main fuctions

History:
o9.o5.2ooo - project started (on military HP Vectra 486sx/25
			 with 100Mb HDD and 8Mb RAM) using BC++ 3.1 and MS-DOS 6.2
21.o7.2ooo - first beta release (for internal use only)
o6.o8.2ooo - ported to Win32. DLL, EXE and LIB versions created

************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "JSI_defs.h"
#include "JSI_errw.h"
#include "JSI_expr.h"
#include "JSI_vars.h"
#include "JSI_pars.h"
#include "JSI_exec.h"
#include "JSI_mem.h"
#include "JSI_trc.h"
#include "JSI_func.h"
#include "JSI_dbg.h"

// global variables
PVar pvGlobalHeap = NULL;

// external function definitions
int JSI_PreprocessCheck(char *szMem, char *szScript); // JSI_PREP.C
TPostfix JSI_Expression(char *szExpression, PVar *pvLocalHeap); // JSI_EXPR.C
extern DWORD dwCurLine; 	// current line number DEFINED IN JSI_PARS.C
extern TPostfix pfError;

/************************************************
JSI_Interprette - interprettes a zero end string in memory buffer
Main routine
************************************************/
TPostfix JSI_Interpret(char *szMem)
{
char *szScript; // script pointer
PToken pParseResult;
TPostfix pfResult = pfError;
//FILE *f;

	if ((szScript = (char *)JSI_Malloc(strlen(szMem)+1)) == NULL) { // get mem buffer
		return pfError;
	}
	else {
				// Preprocess in memory (check valid chars etc.)
		if (JSI_PreprocessCheck(szMem, szScript) == JSIE_SUCCESS) {
/*			f = fopen("temp.$$$", "wt");
			fwrite(szScript, 1, strlen(szScript), f);
			fclose(f);*/

				// parse
			if ((pParseResult = JSI_MainParse(szScript)) != NULL) {
				dwCurLine = JSI_UNKNOWN;	// line not known
				// execute
				pfResult = JSI_Exec(pParseResult, &pvGlobalHeap);
			}
		}
	}
	return pfResult;
}
/************************************************
JSI_InterpretteMem - interprettes a zero end string in memory buffer
Startup and End
************************************************/
TPostfix JSI_EXPORT JSI_InterpretMem(char *szMem)
{
TPostfix pfResult;

	// initialization
	#ifdef _JSI_DEBUG_
	TraceInit();
	#endif
	// global initialization
	JSI_SetError(JSIE_SUCCESS, JSI_UNKNOWN);
	JSI_SetBiultInFunctions();

	// implementation
	pfResult = JSI_Interpret(szMem);

	// close
	JSI_FreeAll();		// free all memory
	#ifdef _JSI_DEBUG_  // write preprocessed file
	TraceClose();
	#endif
	return pfResult;
}
/************************************************
JSI_Interprette_file - interprettes a file
************************************************/
TPostfix JSI_EXPORT JSI_InterpretFile(char *szFileName)
{
FILE *fSrc;		// file handle
DWORD dwFSize;	// file size
char *szScript; // script pointer
TPostfix pfResult;	// result

	if ((fSrc = fopen(szFileName, "rb")) == NULL) { // open script file
		JSI_SetError(JSIE_FILE_NOT_FOUND, JSI_UNKNOWN);
		return pfError;
	}
	if (fseek(fSrc, 0, SEEK_END) != 0) {	      // goto end
		fclose(fSrc);
		JSI_SetError(JSIE_IO_ERROR, JSI_UNKNOWN);
		return pfError;
	}
	dwFSize = ftell(fSrc);			       // get file size
	if ((szScript = JSI_Malloc(dwFSize+10)) == NULL) { // get mem buffer
		fclose(fSrc);
		JSI_FreeAll();		// free all memory
		return pfError;
	}
	rewind(fSrc);				      // goto start
	if (fread(szScript, 1, dwFSize, fSrc) != dwFSize) { // read whole script
		fclose(fSrc);
		JSI_SetError(JSIE_IO_ERROR, JSI_UNKNOWN);
		JSI_FreeAll();		// free all memory
		return pfError;
	}
	szScript[dwFSize] = 0;			   // set end sign
	if ((DWORD)strlen(szScript) != dwFSize) {  // check is this binary file
		fclose(fSrc);
		JSI_SetError(JSIE_INVALID_INPUT_CHAR, JSI_UNKNOWN);
		return pfError;
	}
	pfResult = JSI_InterpretMem(szScript);    // interpete memory buffer

	// end of all
//	JSI_FreeAll(); // free all memory (freed in JSI_InterpretteMem()) TODO
	fclose(fSrc);
	return pfResult;
}
