
/************************************************
Java Script Interpreter
Author: DEM0STEN
Contacts and bug reports -> http://demosten.com OR stjordanov@hotmail.com

memory routines

************************************************/

#include <stdlib.h>
#include <string.h>
#include "JSI_defs.h"
#include "JSI_errw.h"
#include "JSI_trc.h"

// memory pointer keepin' structure
typedef struct TM{
	void* ptr;                	// pointer to pointer
	struct TM *next;        	// pointer to next
} TMem, *PMem;

PMem pMem = NULL;				// Global pointer

/************************************************
AddToMem() - Add memory pointer to list
************************************************/
void AddToMem(void* NewPtr)
{
PMem pNewMem;
	if ((pNewMem = malloc(sizeof(TMem))) == NULL) { // get memory
		JSI_SetError(JSIE_NOT_ENOUGH_MEMORY, JSI_UNKNOWN);
		return;
	}
	memset(pNewMem, 0, sizeof(TMem));	// zero fill
	// copy values
	pNewMem->ptr = NewPtr;
	// push
	pNewMem->next = pMem;
	pMem = pNewMem;
}
/************************************************
JSI_Malloc() - allocate memory and add memory pointer to list
************************************************/
void* JSI_Malloc(DWORD dwSize)
{
void *ptr;
	ptr = malloc(dwSize);
	#ifdef _JSI_DEBUG_MEM_
	#ifdef _16bit_CC_
	Trace("\nAllocated %u bytes (%p)\n", (WORD)dwSize, ptr);
	#else
	Trace("\nAllocated %u bytes (%p)\n", dwSize, ptr);
	#endif // _16bit_CC_
	#endif // _JSI_DEBUG_MEM_
	if (ptr != NULL)
		AddToMem(ptr);
	else
		JSI_SetError(JSIE_NOT_ENOUGH_MEMORY, JSI_UNKNOWN);
	return ptr;
}
/************************************************
JSI_FreeAll() - free all allocated memory from list
************************************************/
void JSI_FreeAll(void)
{
PMem pTemp;
	#ifdef _JSI_DEBUG_MEM_
	Trace("\nDisposing all allocated memory\n");
	#endif
	while (pMem != NULL) {
		pTemp = pMem->next;
		#ifdef _JSI_DEBUG_MEM_
		Trace("Disposing %p\n", pMem->ptr);
		#endif
		free(pMem->ptr);
		free(pMem);
		pMem = pTemp;
	}
}
/************************************************
JSI_Free() - free allocated memory and remove pointer from list
************************************************/
void JSI_Free(void *ptr)
{
PMem pFreeMem, pTemp;
	pFreeMem = pTemp = pMem;
	while (pFreeMem != NULL) {
		pTemp = pTemp->next;
		if ((pTemp != NULL) && (pTemp->ptr == ptr)) {
			pFreeMem->next = pTemp->next;
			#ifdef _JSI_DEBUG_MEM_
			Trace("\nDisposing single pointer %p\n", ptr);
			#endif
			free(ptr);
			free(pTemp);
			break;
		}
		pFreeMem = pTemp;
	}
}

