
/************************************************
Java Script Interpreter
Author: DEM0STEN
Contacts and bug reports -> http://demosten.com OR stjordanov@hotmail.com

variable handing

TODO ret rid of all non raw finctions here and inside jsi_expr.c

TODO TVar.szName not to be [blah]

Tip of the day:
	I HATE TO WRITE SO MUCH CODE WITHOUT HAVING A CHANCE TO TEST IT

************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "JSI_defs.h"
#include "JSI_errw.h"
#include "JSI_expr.h"
#include "JSI_pars.h"
#include "JSI_vars.h"
#include "JSI_mem.h"
#include "JSI_trc.h"
#include "JSI_intr.h"

// global vars
PThis ptThisStack = NULL;	// keeps "this." object pointers in stack

// external vars
extern PVar pvGlobalHeap; // jsi_main.c
extern TPostfix pfCallResult; // DEFINED IN JSI_INTR.C

// DEFINED IN JSI_EXPR.C
extern TPostfix pfError;
TPostfix JSI_Expression(char *szExpression, PVar *pvLocalHeap);
TPostfix JSI_CallFunction(char *szFunction, PVar *pvLocalHeap);
BOOL IsFunction(char *szName);
BOOL Push(PPostfix *ppRoot, char* szValue, double dValue, TOpType Type);

// DEFINED IN JSI_PARS.C
extern DWORD dwCurLine; 	// current line number
/* GetExpression() - extract first expression found in szJS
return: pointer to allocated memory (NULL in case of error)
		character which follows the expression ("]);{}0x0A") -> pcEndChar
		length ot expression -> pdwLength */
char* GetExpression(char *szJS, char *pcEndChar, DWORD *pdwLength);


#ifdef _JSI_DEBUG_VAR_
void PrintVar(PVar pv)
{
PVar mypv = pv;
	Trace("\nPrinting variables: stack (%p)\n", mypv);
	while (mypv != NULL) {
		Trace("Type: %u  dValue: %f szValue: '%s' szName: '%s'\n",
			mypv->Type, mypv->dValue, mypv->szValue, mypv->szName);
		mypv = mypv->next;
	}
}
#endif
/************************************************
GetFirstBreakPosition() -  get position of first '.' or '['
(return 0 for none)
************************************************/
DWORD GetFirstBreakPosition(char *szName)
{
DWORD dwCounter;
	for (dwCounter = 0; dwCounter < strlen(szName); dwCounter++)
		if ((szName[dwCounter] == '.') || (szName[dwCounter] == '['))
			break;
	if (dwCounter < strlen(szName))
		return dwCounter;
	return 0;
}
/************************************************
GetSubVarResult() - Calculate szName and return it as a postfix
************************************************/
TPostfix GetSubVarResult(char *szName, DWORD *pdwLength, PVar pvLocalHeap)
{
char *szExpression;	// expression ptr
char cEndChar;		// last expression char
DWORD dwExprLen;	// expression length
TPostfix pfResult;	// expression result

	#ifdef _JSI_DEBUG_
	Trace("\nGetSubVarResult(): Getting sub variable: '%s'\n", szName);
	#endif
	switch (szName[0]) {
	case '.':
		if ((dwExprLen = GetFirstBreakPosition(&szName[1])) < 1)
			dwExprLen = strlen(&szName[1]);
		if (!dwExprLen)
			return pfError;
		if ((pfResult.szValue = JSI_Malloc(dwExprLen+1)) == NULL)
			return pfError;
		strncpy(pfResult.szValue, &szName[1], dwExprLen);
		pfResult.szValue[dwExprLen] = 0;
		pfResult.Type = opConstStr;
		break;
	case '[':
		szExpression = GetExpression(szName+1, &cEndChar, &dwExprLen);
		if ((szExpression == NULL) || (cEndChar != ']') || (dwExprLen == 0))
			return pfError;
		pfResult = JSI_Expression(szExpression, &pvLocalHeap);
		JSI_Free(szExpression);	// free memory
		dwExprLen++; // this is because of 'GetExpression(szName+1, ...'

		switch (pfResult.Type) {
		case opVarStr:
		case opConstStr: // make new copy of the string
			if ((szExpression = JSI_Malloc(strlen(pfResult.szValue))) == NULL)
				return pfError;
			strcpy(szExpression, pfResult.szValue);
			pfResult.szValue = szExpression;
			break;
		case opConstNum:
			if ((pfResult.szValue = JSI_Malloc(50)) == NULL)
				return pfError;
			ultoa((DWORD)pfResult.dValue, pfResult.szValue, 10);
			pfResult.Type = opConstStr;
			break;
		default: return pfError;
		} // switch

	} // switch
	*pdwLength = dwExprLen+1;
	return pfResult;
}
/************************************************
FindSubVar() - find sub variable (return NULL for error)
************************************************/
PVar FindSubVar(char *szName, PVar obj_vars, PVar pvLocalHeap)
{
PVar mypv = obj_vars;
BOOL bCallNew;   	// shall we call new FindSubVar
DWORD dwExprLen;	// expression length
TPostfix pfResult;	// expression result

	#ifdef _JSI_DEBUG_
	Trace("\nFindSubVar(): Searching sub variable: '%s' heap: (%p)\n", szName, pvLocalHeap);
	#endif
	#ifdef _JSI_DEBUG_VAR_
	PrintVar(obj_vars);
	#endif
	pfResult = GetSubVarResult(szName, &dwExprLen, pvLocalHeap);
	if ((pfResult.Type == opError) || (pfResult.Type == opNone))
		return NULL;
	bCallNew = ((strchr(".[", szName[dwExprLen]) != NULL) &&
				(strlen(&szName[dwExprLen])));

	// search
	while (mypv != NULL) {
		if (strcmp(mypv->szName, pfResult.szValue) == 0) {
			JSI_Free(pfResult.szValue);
			if (bCallNew)
				return FindSubVar(&szName[dwExprLen], mypv->obj_vars, pvLocalHeap);
			else
				return mypv;
		}
		mypv = mypv->next;
	}
	return NULL;
}
/************************************************
JSI_FindVar() - find variable (return NULL for error)
************************************************/
PVar JSI_FindVar(char *szName, PVar pvLocalHeap)
{
PVar mypv = pvLocalHeap;
DWORD dwBreakPtr;	// address of first '.' or '['
DWORD dwLen;        // length of first variable

	#ifdef _JSI_DEBUG_
	Trace("\nJSI_FindVar(): Searching variable: '%s' heap: (%p)\n", szName, pvLocalHeap);
	#endif
	#ifdef _JSI_DEBUG_VAR_
	PrintVar(pvLocalHeap);
	#endif
	if ((dwBreakPtr = GetFirstBreakPosition(szName)) != 0)
		dwLen = dwBreakPtr;
	else
		dwLen = strlen(szName);
	// check is this "this" reserved word
	if (memcmp(szName, "this", dwLen) == 0) {
		if (ptThisStack != NULL)
			if (dwBreakPtr)
				return FindSubVar(&szName[dwBreakPtr], ptThisStack->pVar, pvLocalHeap);
			else
				return ptThisStack->pVar;
		else {
			JSI_SetError(JSIE_INVALID_VARIABLE_TYPE, JSI_UNKNOWN);
			return NULL;
		}
	}
	// search local heap
	while (mypv != NULL) {
		if ((memcmp(mypv->szName, szName, dwLen) == 0) && (strlen(mypv->szName) == dwLen)) { // TODO !!! obj[i] == obj_name
			if (dwBreakPtr)
				return FindSubVar(&szName[dwBreakPtr], mypv->obj_vars, pvLocalHeap);
			else
				return mypv;
		}
		mypv = mypv->next;
	}
	if (pvLocalHeap != pvGlobalHeap)
		// search global heap
		return JSI_FindVar(szName, pvGlobalHeap);
	return NULL;
}
/************************************************
JSI_GetVarValue() - get variable value (return opError for error)
************************************************/
TOpType JSI_GetVarValue(char *szName, char **szValue, double *dValue, PVar *ppvHeap)
{
PVar pvar;
TPostfix pf;
pJSI_VarGet func;

	#ifdef _JSI_DEBUG_
	Trace("\nJSI_GetVarValue(): '%s' stack (%p)\n", szName, *ppvHeap);
	#endif
	if (IsFunction(szName)) {
		pf = JSI_CallFunction(szName, ppvHeap);
		*dValue = pf.dValue;
		*szValue = pf.szValue;
		return pf.Type;
	}

	if ((pvar = JSI_FindVar(szName, *ppvHeap)) != NULL) {
		switch (pvar->Type) {
		case varNum: *szValue = NULL; *dValue = pvar->dValue; return opConstNum;
		case varStr: *szValue = pvar->szValue; *dValue = 0.0; return opConstStr;
		case varObj: case varFunc: case varExtFunc:
			return opVarStr;
		case varExtVar:
			func = (pJSI_VarGet)pvar->code;
			if (func) {
				pfCallResult.Type = opError;
				func();
				if (pfCallResult.Type == opError)
					JSI_SetError(JSIE_EXTR_FUNC_MUST_RETURN, JSI_UNKNOWN);
				else {
					*dValue = pfCallResult.dValue;
					*szValue = pfCallResult.szValue;
				}
				return pfCallResult.Type;
			}
			else {
				JSI_SetError(JSIE_EXTR_VAR_IS_WRITE_ONLY, JSI_UNKNOWN);
				return opError;
			}
		default:
			JSI_SetError(JSIE_INVALID_VARIABLE_TYPE, JSI_UNKNOWN);
			return opError;
		}
	}
	*szValue = NULL;
	*dValue = 0.0;
	return opConstNum;
//	return (JSI_SetVarNum(szName, 0.0, &pvGlobalHeap) ? opConstNum : opError);
}
/************************************************
JSI_SetVarNum() - set variable number value
************************************************/
PVar JSI_SetVarNum(char *szName, double dValue, PVar *ppvHeap)
{
	return JSI_SetVar(szName, NULL, dValue, varNum, NULL, NULL, NULL, ppvHeap);
}
/************************************************
JSI_SetVarStr() - set variable string value
************************************************/
PVar JSI_SetVarStr(char *szName, char *szValue, PVar *ppvHeap)
{
	return JSI_SetVar(szName, szValue, 0.0, varStr, NULL, NULL, NULL, ppvHeap);
}
/************************************************
JSI_AddVar() - add variable (RAW function)
************************************************/
PVar JSI_AddVar(char *szName, char *szValue, double dValue,
	TVarType Type, PArgs params, PVar obj_vars, PToken code, PVar *ppvHeap)
{
PVar pTempVar;
	#ifdef _JSI_DEBUG_
	Trace("\nJSI_AddVar(): '%s'  Type: %d  heap (%p)\n", szName, Type, *ppvHeap);
	#endif
	if (szName == NULL) {
		JSI_SetError(JSIE_INVALID_OPERATION, JSI_UNKNOWN);
		return NULL;
	}
	if ((pTempVar = JSI_Malloc(sizeof(TVar))) == NULL)  // get memory
		return NULL;
	memset(pTempVar, 0, sizeof(TVar));	// zero fill
	// copy values
	strncpy(pTempVar->szName, szName, MAX_VALUE_SIZE);
	pTempVar->szValue = szValue;
	pTempVar->dValue = dValue;
	pTempVar->Type = Type;
	pTempVar->params = params;
	pTempVar->obj_vars = obj_vars;
	pTempVar->code = code;
	// push
	pTempVar->next = *ppvHeap;
	*ppvHeap = pTempVar;

	#ifdef _JSI_DEBUG_VAR_
	PrintVar(*ppvHeap);
	#endif
	return pTempVar;
}
/************************************************
GetSubVarPos() - get position of first var
examples 'ab.ab'  or 'ab["ab"]'
			^           ^
************************************************/
DWORD GetSubVarPos(char *szName)
{
char *cPoint, *cLastIndex, *szExpression, cEndChar;
DWORD dwExprLen;

	if (szName[strlen(szName)-1] != ']')
		if ((cPoint = strrchr(szName, '.')) == NULL)
			return 0;
		else
			return cPoint - szName;
	else {
		cPoint = szName;
		while ((cPoint = strchr(cPoint, '[')) != NULL) {
			cLastIndex = cPoint;
			szExpression = GetExpression(cPoint+1, &cEndChar, &dwExprLen);
			if ((szExpression == NULL) || (cEndChar != ']') || (dwExprLen == 0))
				return 0; // TODO set error
			JSI_Free(szExpression);	// free memory
			cPoint += dwExprLen+1;
		}
		if (cLastIndex)
			return cLastIndex - szName;
		else
			return 0;
	}
}
/************************************************
JSI_SetVar() - set variable (RAW function)
************************************************/
PVar JSI_SetVar(char *szName, char *szValue, double dValue,
	TVarType Type, PArgs params, PVar obj_vars, PToken code, PVar *ppvHeap)
{
PVar pvar, *ppVar = &pvGlobalHeap; // ppvHeap;
DWORD dwSubVarPos,
	dwExprLen;
char cTemp;
TPostfix pfResult;
//char *szNewValue = szValue;

	#ifdef _JSI_DEBUG_
	Trace("\nJSI_SetVar(): '%s' szValue: '%s' dValue: '%f' heap (%p)\n",
		szName, szValue, dValue, *ppvHeap);
	#endif
	if (IsFunction(szName)) {
		JSI_SetError(JSIE_CANNOT_ASSIGN_TO_FUNCTION, JSI_UNKNOWN);
		return NULL;
	}
	dwSubVarPos = GetSubVarPos(szName);
	if (dwSubVarPos) { // this is complex var 'a.b' or 'a["b"]'
		cTemp = szName[dwSubVarPos];
		szName[dwSubVarPos] = 0;
		if ((pvar = JSI_FindVar(szName, *ppvHeap)) == NULL) {
			JSI_SetError(JSIE_INVALID_VARIABLE_NAME, JSI_UNKNOWN);
			return NULL;
		}
		szName[dwSubVarPos] = cTemp;
		ppVar = &(pvar->obj_vars);
		pvar = FindSubVar(&szName[dwSubVarPos], pvar->obj_vars, *ppvHeap);
	}
	else
		pvar = JSI_FindVar(szName, *ppvHeap); // simple var 'a'
	if (pvar != NULL) {
		if ((pvar->Type == varFunc) && ((Type != varFunc) && (Type != varExtFunc))) { // TODO ?????
			JSI_SetError(JSIE_CANNOT_ASSIGN_TO_FUNCTION, JSI_UNKNOWN);
			return NULL;
		}
		if (pvar->Type == varExtVar) { // external var ?
			pJSI_VarSet func = (pJSI_VarSet)pvar->szValue;
			if (func) {
				pfCallResult.Type = opNone;
				func(Type, szValue, dValue);
				return pvar;
			}
			else {
				JSI_SetError(JSIE_EXTR_VAR_IS_READ_ONLY, JSI_UNKNOWN);
				return NULL;
			}
		}
/*		if (pvar->Type == varStr) {
			JSI_Free(pvar->szValue);
			if ((szNewValue = CopyString(szValue)) == NULL)
				return NULL;
		}*/
		pvar->szValue = szValue;
		pvar->dValue = dValue;
		pvar->Type = Type;
		pvar->params = params;
		pvar->obj_vars = obj_vars;
		pvar->code = code;
		return pvar;
	}
	if (dwSubVarPos) { // this is complex var 'a.b' or 'a["b"]'
		pfResult = GetSubVarResult(&szName[dwSubVarPos], &dwExprLen, *ppvHeap);
		if ((pfResult.Type == opError) || (pfResult.Type == opNone))
			return NULL; // TODO set error
		pvar = JSI_AddVar(pfResult.szValue, szValue, dValue, Type, params,
			obj_vars, code, ppVar);
		JSI_Free(pfResult.szValue);
		return pvar;
	}
	return JSI_AddVar(szName, szValue, dValue, Type, params, obj_vars,
		code, ppVar);
}
/************************************************
JSI_SetLocalVar() - set local variable
Note: here is used a little trick. i set global heap to
point to local heap, then use JSI_SetVar()
************************************************/
PVar JSI_SetLocalVar(char *szName, char *szValue, double dValue,
	TVarType Type, PArgs params, PVar obj_vars, PToken code, PVar *ppvHeap)
{
PVar pvTemp, pvResult;

	pvTemp = pvGlobalHeap;
	pvGlobalHeap = *ppvHeap;
	pvResult = JSI_SetVar(szName, szValue, dValue, Type, params,
		obj_vars, code, ppvHeap);
	*ppvHeap = pvGlobalHeap;
	pvGlobalHeap = pvTemp;
	return pvResult;
}
/************************************************
JSI_AddLocalVar() - add local variable only if it doesn't exist
Note: here is used a little trick. i set global heap to
point to local heap, then use JSI_SetVar()
************************************************/
PVar JSI_AddLocalVar(char *szName, char *szValue, double dValue,
	TVarType Type, PArgs params, PVar obj_vars, PToken code, PVar *ppvHeap)
{
PVar pvTemp, pvResult;

	pvTemp = pvGlobalHeap;
	pvGlobalHeap = *ppvHeap;
	if ((pvResult = JSI_FindVar(szName, *ppvHeap)) == NULL)
		pvResult = JSI_SetVar(szName, szValue, dValue, Type, params,
			obj_vars, code, ppvHeap);
	*ppvHeap = pvGlobalHeap;
	pvGlobalHeap = pvTemp;
	return pvResult;
}
/************************************************
JSI_CopyVar() - copy variable szSrc to szDest
************************************************/
PVar JSI_CopyVar(char *szDest, char *szSrc, PVar *ppvHeap)
{
PVar pvSrc;
	#ifdef _JSI_DEBUG_
	Trace("\nJSI_CopyVar(): '%s' -> '%s'  heap (%p)\n", szSrc, szDest, *ppvHeap);
	#endif
	if ((pvSrc = JSI_FindVar(szSrc, *ppvHeap)) == NULL) {
		JSI_SetError(JSIE_INVALID_OPERATION, JSI_UNKNOWN);
		return NULL;
	}
	return JSI_SetVar(szDest, pvSrc->szValue, pvSrc->dValue,
		pvSrc->Type, pvSrc->params, pvSrc->obj_vars, pvSrc->code, ppvHeap);
}
/************************************************
JSI_AddArg() - add argument to the end of argument list
************************************************/
PArgs JSI_AddArg(char *szName, PArgs *ppArgs)
{
PArgs pTempArg;
	#ifdef _JSI_DEBUG_
	Trace("\nJSI_AddArg(): '%s' args (%p)\n", szName, *ppArgs);
	#endif
	if ((pTempArg = JSI_Malloc(sizeof(TArgs))) == NULL)  // get memory
		return NULL;
	memset(pTempArg, 0, sizeof(TArgs));	// zero fill
	pTempArg->szName = szName; // copy value
	// add to tail
	if (*ppArgs != NULL) {
		while ((*ppArgs)->next != NULL)
			ppArgs = &((*ppArgs)->next);
		(*ppArgs)->next = pTempArg;
	}
	else
		*ppArgs = pTempArg;
	return pTempArg;
}
/************************************************
JSI_PushThis() - add variable to this stack
************************************************/
BOOL JSI_PushThis(PVar pvThis)
{
	PThis ptNew = JSI_Malloc(sizeof(TThis));
	if (ptNew == NULL)
		return FALSE;
	ptNew->pVar = pvThis;
	ptNew->next = ptThisStack;
	ptThisStack = ptNew;
	return TRUE;
}
/************************************************
JSI_PopThis() - remove 'last in' variable from this stack
************************************************/
void JSI_PopThis(void)
{
PThis ptTemp;
	ptTemp = ptThisStack;
	ptThisStack = ptThisStack->next;
	if (ptTemp)
		JSI_Free(ptTemp);
}
/************************************************
JSI_SetThisByName() - set 'this.' for a["b"] to be = a
if pszSmallName != NULL set it to "b"
************************************************/
BOOL JSI_SetThisByName(char *szName, char **pszSmallName, PVar *ppvHeap)
{
PVar pvar;
BOOL bResult = FALSE;
char cTemp;
DWORD dwExprLen;
TPostfix pfResult;

	DWORD dwSubVarPos = GetSubVarPos(szName);
	if (dwSubVarPos) { // this is complex var 'a.b' or 'a["b"]'
		cTemp = szName[dwSubVarPos];
		szName[dwSubVarPos] = 0;
		if ((pvar = JSI_FindVar(szName, *ppvHeap)) == NULL) {
			JSI_SetError(JSIE_INVALID_VARIABLE_NAME, JSI_UNKNOWN);
			return FALSE;
		}
		szName[dwSubVarPos] = cTemp;
		bResult = JSI_PushThis(pvar);
		// get small name
		if (pszSmallName) {
			pfResult = GetSubVarResult(&szName[dwSubVarPos], &dwExprLen, *ppvHeap);
			if ((pfResult.Type == opError) || (pfResult.Type == opNone))
				return FALSE; // TODO set error
			*pszSmallName = pfResult.szValue;
		}
	}
	else
		if (pszSmallName)
			*pszSmallName = szName;

	return bResult;
}
/************************************************
VarIn() - return true if a variable named szGoal is inside heap pvSrc
return pointer to next variable too
************************************************/
BOOL VarIn(PVar pvSrc, char *szGoal, PVar *ppvNext)
{
PVar mypv = pvSrc;
BOOL bFound = FALSE;

	while (mypv != NULL) {
		if (strcmp(mypv->szName, szGoal) == 0) {
			bFound = TRUE;
			break;
		}
		mypv = mypv->next;
	}
	if (bFound) {
		*ppvNext = mypv->next;
		return TRUE;
	}
	return FALSE;
}
/************************************************
CopyString() - make a copy of string (return NULL in case of error)
************************************************/
char* CopyString(char *szString)
{
	char *pcResult = JSI_Malloc(strlen(szString)+1);
	if (pcResult != NULL)
		strcpy(pcResult, szString);
	return pcResult;
}
/************************************************
InOperation() - calculates result of ' in ' operation between pfOp1 and pfOp2
************************************************/
BOOL InOperation(char *szOp1Name, TPostfix pfOp1, TPostfix pfOp2,
	PPostfix *out, PVar *ppvHeap)
{
PVar pvNext, pvResult;
char *pcName = NULL;  // variable name

	if ((!szOp1Name) || (pfOp1.Type == opVar)) { // first operand is invalid
		JSI_SetError(JSIE_INVALID_OPERATION, JSI_UNKNOWN);
		return FALSE;
	}
	if (pfOp2.Type != opVarStr) // second operation is not an object
		Push(out, NULL, 0.0, opConstNum); // return FALSE
	if ((pvResult = JSI_FindVar(pfOp2.szValue, *ppvHeap)) == NULL) {
		JSI_SetError(JSIE_INVALID_OPERATION, JSI_UNKNOWN);
		return FALSE;
	}
	if (pvResult->obj_vars == NULL) { // object has no vars
		Push(out, NULL, 0.0, opConstNum); // return FALSE
		return TRUE;
	}
	if ((pfOp1.Type == opConstNum) ||
		(!VarIn(pvResult->obj_vars, pfOp1.szValue, &pvNext))) {
		if ((pcName = CopyString(pvResult->obj_vars->szName)) == NULL)
			return FALSE;
	}
	else
		if (pvNext)
			if ((pcName = CopyString(pvNext->szName)) == NULL)
				return FALSE;
	if (pcName != NULL) {
		if (!JSI_SetVarStr(szOp1Name, pcName, ppvHeap))
			return FALSE;
		Push(out, pcName, 0.0, opConstStr); // return TRUE
		return TRUE;
	}
	Push(out, NULL, 0.0, opConstNum); // return FALSE
	return TRUE;
}
