
/************************************************
Java Script Interpreter
Author: DEM0STEN
Contacts and bug reports -> http://demosten.com OR stjordanov@hotmail.com

variable handing definitions

************************************************/

#ifndef _JSI_VARS_H_
#define _JSI_VARS_H_

#ifndef _JSI_EXPR_H_
#include "JSI_expr.h"
#endif

#ifndef _JSI_PARS_H_
#include "JSI_pars.h"
#endif

// define variable types
#define varError		0		// error (use JSI_GetError() to take error number)
#define varNum			1		// number
#define varStr			2		// string
#define varFunc			3		// internal defined function (name)
#define varObj			4		// object (name)
#define varExtFunc		5		// external function (name)
#define varExtVar		6		// external var (name)

typedef int TVarType;

// functions arguments names structure
typedef struct TAR{
	char *szName;		      // pointer to name
	struct TAR *next;	      // pointer to next
} TArgs, *PArgs;

// variable structure
typedef struct TVR {
	char szName[MAX_VALUE_SIZE];  // variable name (all)
	char *szValue;		      // string of value (varConstStr)
	double dValue;		      // double of value (varConstNum)
	TVarType Type;		      // variable type (all)
	PArgs params;		      // pointer to params (varFunc)
	struct TVR *obj_vars;	  // pointer to object vars (varFunc, varObj)
	struct TVR *next;	      // pointer to next (all)
	PToken code;		      // pointer to code (varFunc)
} TVar, *PVar;

// this pointers structure
typedef struct TTHIS{
	PVar pVar;			      // pointer to variable
	struct TTHIS *next;	      // pointer to next
} TThis, *PThis;

#ifdef _JSI_DEBUG_VAR_
void PrintVar(PVar pv);
#endif
PVar JSI_FindVar(char *szName, PVar pvLocalHeap);
TOpType JSI_GetVarValue(char *szName, char **szValue, double *dValue, PVar *ppvHeap);
PVar JSI_SetVarNum(char *szName, double dValue, PVar *ppvHeap);
PVar JSI_SetVarStr(char *szName, char *szValue, PVar *ppvHeap);
PVar JSI_AddVar(char *szName, char *szValue, double dValue,
	TVarType Type, PArgs params, PVar obj_vars, PToken code, PVar *ppvHeap);
PVar JSI_SetVar(char *szName, char *szValue, double dValue,
	TVarType Type, PArgs params, PVar obj_vars, PToken code, PVar *ppvHeap);
PVar JSI_SetLocalVar(char *szName, char *szValue, double dValue,
	TVarType Type, PArgs params, PVar obj_vars, PToken code, PVar *ppvHeap);
PVar JSI_AddLocalVar(char *szName, char *szValue, double dValue,
	TVarType Type, PArgs params, PVar obj_vars, PToken code, PVar *ppvHeap);
PVar JSI_CopyVar(char *szDest, char *szSrc, PVar *ppvHeap);
PArgs JSI_AddArg(char *szName, PArgs *ppArgs);
BOOL JSI_PushThis(PVar pvThis);
void JSI_PopThis(void);
BOOL JSI_SetThisByName(char *szName, char **pszSmallName, PVar *ppvHeap);
char* CopyString(char *szString);
BOOL InOperation(char *szOp1Name, TPostfix pfOp1, TPostfix pfOp2,
	PPostfix *out, PVar *ppvHeap);

#endif