
/************************************************
Java Script Interpreter
Author: DEM0STEN
Contacts and bug reports -> http://demosten.com OR stjordanov@hotmail.com

EXE build (DLL example)

This example demonstrates:
	user defined errors
	user defined function add
	user defined variable add
	error codes processing
	how to get script error
	how to set script error

************************************************/

#include <stdio.h>
#include "JSI.h"

#define JSIE_VALUE_MUST_BE_POSITIVE		JSIE_USERBASE+1		// user defined error number (5001)

char szStartMessage[]=
"* Demosten's Java Script Interpretter ver.0 (beta 2) * VIII.2000\n"
"* Contacts at http://demosten.com or stjordanov@hotmail.com\n"
"* DLL usage example\n\n";

static int iProba = -2;		// used to keep user defined variable

/*********************************************************/
void PrintHelp(void)
{
	printf("Syntax: JSI_exe <file_name>\n");
}
/*********************************************************
user defined function used to display all passed arguments
depending on type (number or string)
*********************************************************/
int JSI_CALLBACK test(int argc, PVar argv)
{
int iCounter;
char *szValue;
double dValue;

	for (iCounter = 0; iCounter < argc; iCounter++) {
		if (JSI_GetParam(iCounter, &szValue, &dValue, argv) == varNum) { // param is a number
			printf("%f", dValue);
		}
		else // all other types can be processed as strings
			printf("%s", szValue);
	}
	return 0;
}
/*********************************************************
user defined function used to return the value of user defined variable to script
Note: if variable is a string you pass a pointer to it
but do not have to keep allocated memory
a copy of the string will be created internaly
*********************************************************/
int JSI_CALLBACK GetMyVar(void)
{
	JSI_SetResult(NULL, (double)iProba, varNum); // THIS IS A MUST !!!
	return 0;
}
/*********************************************************
user defined function used to set the value of user defined variable
*********************************************************/
int JSI_CALLBACK SetMyVar(TVarType Type, char* szValue, double dValue)
{
	if ((Type == varNum) && (dValue >= 0))
		iProba = (int)dValue;
	else
		// in order to demonstrate user defined errors i set my error if given value
		// is not a positive number
		JSI_SetErrorNum(JSIE_VALUE_MUST_BE_POSITIVE);
	return 0;
}
/*********************************************************/
int main(int argc, char *argv[])
{
char szError[500];	// to store error (if any) as string
DWORD dwErrLine;	// error line number

	printf("%s", szStartMessage);	// blah

	if (argc != 2)
		PrintHelp();
	else {
		// set user defined functions
		JSI_AddExtrFunction("write", test);
		// set user defined variables
		JSI_AddExtrVar("ExternalVar", GetMyVar, SetMyVar);
//		JSI_AddExtrVar("ExternalVar", GetMyVar, NULL);	// make it read only
//		JSI_AddExtrVar("ExternalVar", NULL, SetMyVar); // make it write only

		JSI_InterpretFile(argv[1]);
		if (JSI_GetError(&dwErrLine, NULL) < JSIE_USERBASE)	// who's error is this
			JSI_GetErrorStringEnglish(szError);		// JSI
		else	// this is my error
			sprintf(szError, "Error on line %u -> Value of 'ExternalVar' must be positive",
				dwErrLine);
		printf("Total result: %s\n", szError);
	}

	return 0;
}
/*********************************************************/
